#
#  
#
__Version__ = "0.1"
__Owner__ = "seLain"
__Update_Date__ = "2006/09/25"

import Utils
from configobj import ConfigObj

#
# [seLain] the calculate_design_properties function is actually exactly the same with 
# QualityAccessment.calculate_quality_attributes the integration of these two function 
# into single one should be considered
#
def calculate_design_properties(metricFileName, propertyFileName):
	
	def calculate_by_equation(equation, projectMetric):
		value = 0
		for itemKey in equation.keys():
			#quoteKey = '"' + itemKey + '"'	# a little dirty here ... key inconsistency
			quoteKey = itemKey
			if quoteKey in projectMetric.keys():
				value = value + float(equation[itemKey]) * float(projectMetric[quoteKey])
			else:
				print quoteKey, projectMetric
				raise Exception('Can not find a match metric.')
		return value
	
	## read equation configuration
	from configobj import ConfigObj
	config = ConfigObj("property.conf")
	sectionMapping = config['Metrics2DesignProperties']
	## rdesign metric csv file
	dictProjectMetric = Utils.readCSV(metricFileName)
	## calculate
	dictProjectDP = {}	# format : {'"project1"' : { '"QA1"': value, }, }
	for key in dictProjectMetric.keys():	# key = project name
		projectMetric = dictProjectMetric[key]
		dictProjectDP[key] = {}	# initial a record in quality attribute dict
		for mappingName in sectionMapping.keys():
			mapping = sectionMapping[mappingName]
			value = calculate_by_equation(mapping, projectMetric)
			dictProjectDP[key][mappingName] = str(value)
	## write to csv file
	Utils.writeCSV(dictProjectDP, propertyFileName)
	
	return propertyFileName
	
############
## for testing ##
############
# calculate_design_properties("CurrentMetricsOutput.csv", "CurrentDPOutput.csv")
	