__Version__ = "0.1"
__Owner__ = "seLain"
__Update_Date__ = "2006/09/25"

import doxygen
from CSV import *
from DesignPropertyAccessment import calculate_design_properties
from QualityAccessment import calculate_quality_attributes
from configobj import ConfigObj
import Utils

if __name__ == '__main__':
	
	config = ConfigObj("accessment.conf")
	sectionOutputs = config['OutputFileNames']
	
	## generate doxygen xml files from sources
	sectionDoxygen = config['Doxygen']
	if sectionDoxygen['DoxygenStatus'] == 'On':
		doxygen.automatic_doxygen_execution()
		
	## extract metrics result
	sectionMetrics = config['MetricsLevel']
	if sectionMetrics['MetricsStatus'] == 'On':
		csv = CSV(sectionOutputs['MetricsOutputFileName'])
		csv.writeNewFile()
	
	## calcualte design properties
	sectionDP = config['DesignPropertyLevel']
	if sectionDP['DesignPropertyStatus'] == 'On':
		calculate_design_properties(sectionOutputs['MetricsOutputFileName'], \
						sectionOutputs['DesignPropertiesOutputFileName'])
	
	## normalization and writing result
	sectionNormalization = config['DesignPropertyNormalization']
	if sectionNormalization['NormalizationStatus'] == 'On':
		Utils.normalize_table_in_CSV_file(sectionNormalization['NormalizationBase'], \
							sectionOutputs['DesignPropertiesOutputFileName'], \
							sectionOutputs['NormalizedDesignPropertiesOutputFileName'])

	## calculate quality attributes
	sectionQA = config['QualityAttributeLevel']
	if sectionQA['QualityAttributeStatus'] == 'On':
		calculate_quality_attributes(sectionOutputs['NormalizedDesignPropertiesOutputFileName'], \
						sectionOutputs['QualityAttributesOutputFileName'])
	
	
							