#
# QualityAccessment Module for DBSE-2006-Task-OSS-A
# This the primary module ot this task
#
__Version__ = "0.1"
__Owner__ = "seLain"
__Update_Date__ = "2006/09/25"

import Utils
from configobj import ConfigObj

'''
calculate_quality_attributes : calculate the quality attributs value
	from a design propertity csv file
@param propertyFileName : name of the input design propertity csv file
@param qualityFileName : name of the output quality attribute csv file
@post-condition : a quality attribute csv file
'''
def calculate_quality_attributes(propertyFileName, qualityFileName):
	
	def calculate_by_equation(equation, projectDP):
		value = 0
		for itemKey in equation.keys():
			#quoteKey = '"' + itemKey + '"'	# a little dirty here ... key inconsistency
			quoteKey = itemKey
			if quoteKey in projectDP.keys():
				value = value + float(equation[itemKey]) * float(projectDP[quoteKey])
			else:
				print quoteKey, projectDP
				raise Exception('Can not find a match design property.')
		return value
	
	## read equation configuration
	from configobj import ConfigObj
	config = ConfigObj("accessment.conf")
	sectionEquation = config['IndexComputationEquation']
	## rdesign propertity csv file
	dictProjectDP = Utils.readCSV(propertyFileName)
	## calculate
	dictProjectQA = {}	# format : {'"project1"' : { '"QA1"': value, }, }
	for key in dictProjectDP.keys():	# key = project name
		projectDP = dictProjectDP[key]
		dictProjectQA[key] = {}	# initial a record in quality attribute dict
		for eqaName in sectionEquation.keys():
			equation = sectionEquation[eqaName]
			value = calculate_by_equation(equation, projectDP)
			dictProjectQA[key][eqaName] = str(value)
	## write to csv file
	Utils.writeCSV(dictProjectQA, qualityFileName)

	return qualityFileName

############
## for testing ##
############
# calculate_quality_attributes("DBSE-Task-OSSA-MFC-ver1-to-Ver5-add-Composition.csv", "DBSE-Task-OSSA-MFC-ver1-to-Ver5-quality.csv")
