import os
from extracter import DoxygenXMLExtractor
from metrics import *

class CSV:
	
	meanDic = {'NOP':NOP_C_Metric, 'MOA':MOA_C_Metric, 'CIS':CIS_C_Metric, 'NOM':NOM_C_Metric, \
			'DAM':DAM_C_Metric,'DCC':DCC_C_Metric,'CAM':CAM_C_Metric,'MFA':MFA_C_Metric}
	sumDic = {'DSC':DSC_C_Metric}
	rawDic = {'NOH':NOH_P_Metric, 'ANA':ANA_P_Metric}
	
	'''
	@param outputFN : output filename of metrics measurement result
	'''
	def __init__(self, outputFN):
		self.proList = self.extractor()	
		self.fileName = outputFN
	
	def all_paths(self, projPath = ""):
		pathList = []
		listAllFilenames = os.listdir(projPath+'projects')
		for dir in listAllFilenames:
			pathList.append('projects/'+dir + '/xml')
		return pathList

	def all_dir_paths(self,projPath = ""):
		pathList = []
		for anypath in self.all_paths(projPath):
			if os.path.isdir(anypath):
				pathList.append(anypath)
		return pathList
	
	
	def extractor(self):
		project_pathList = self.all_dir_paths()
		print 'project_pathList:', project_pathList
		proList = {}
		for path in project_pathList:
			# [seLain] path.split['/'][-1] is project directory name, wich is usually project name with version
			projectName = '-'.join(path.split('/')[-2].split('-')[0:2])
			print projectName, '------- extracting'
			doxyExtractor = DoxygenXMLExtractor()
			proList[projectName]  = (doxyExtractor.extract_project(path))
			print projectName, '------- extracted'
		return proList	


	def writeNewFile(self ):
		f = open(self.fileName, 'w')
		f.write("project name\\metric name ")
		
		projectObj= self.proList[self.proList.keys()[0]]
		## [seLain] the purpose it the column names, the project name is not important...
		## this is dirty code, must be refactored later...
		pcsv = ProjectCSV("", projectObj, self.meanDic, self.sumDic, self.rawDic)
		dict = pcsv.getDict()
		for metric in dict.keys():
			f.write("," + metric)
		f.write("\n")
		
		## write actual numbers
		for projectName in self.proList.keys():
			projectObj = self.proList[projectName]
			pcsv = ProjectCSV(projectName, projectObj, self.meanDic, self.sumDic, self.rawDic)
			dict = pcsv.getDict()
			f.write(projectName)
			for metric in dict.keys():
				f.write("," )
				f.write(dict[metric].__str__())
			f.write("\n")
		f.close()
		
		return self.fileName
	
	
	
class ProjectCSV:
	
	metricsValue = {}
	
	def __init__(self, projectName , projectObj, mean_dict, sum_dict, raw_dict):
		self.projectName = projectName
		self.projObj = projectObj
		self.meanDic = mean_dict
		self.sumDic = sum_dict
		self.rawDic = raw_dict
	
	def getSum(self,pro):
		sumDict = {}
		for metric in self.sumDic.keys():
			temp = Sum(pro, self.sumDic[metric])
			sumDict[metric] = temp['sum']
		return sumDict

	def getRaw(self,pro):
		rawDict = {}
		for metric in self.rawDic.keys():
			temp = self.rawDic[metric](pro)
			rawDict[metric] = temp
		return rawDict

	def getMean(self,pro):
		meanDict = {}
		for metric in self.meanDic.keys():
			temp = Mean(pro, self.meanDic[metric])
			meanDict[metric] =  temp['average']
		return meanDict
		
	def getDict(self):
		self.metricsValue = {}
		m = self.getMean(self.projObj)
		r = self.getRaw(self.projObj)
		s = self.getSum(self.projObj)
		
		for key in m.keys():
			self.metricsValue[key] = m[key]
		for key in r.keys():
			self.metricsValue[key] = r[key]
		for key in s.keys():
			self.metricsValue[key] = s[key]
			
		return self.metricsValue
		
	
	
		
		
		
		
	

	