#
# Automatic doxygen execution tool
#
__Version__ = "0.1"
__Owner__ = "seLain"
__Update_Date__ = "2006/09/30"

def automatic_doxygen_execution():
	
	## read all project sources directory paths
	import os
	PROJECT_SRC_PATH = os.getcwd() + '\\project_srcs\\'
	OUTPUT_DIR_PATH = os.getcwd() + '\\projects\\'
	import os
	srcPaths = os.listdir(PROJECT_SRC_PATH)
	srcFullPaths = []
	for path in srcPaths:
		if not path.endswith('svn'):
			srcFullPaths.append(PROJECT_SRC_PATH+path)
	
	## automatically generate configuration file
	for path in srcFullPaths:
		print path
		projectDirName = path.split('\\')[-1]
		print '[ProjectName]', projectDirName
		projectName, projectVersion = projectDirName.split('-')
		print projectName, projectVersion
		
		configFile = file('Doxyfile')
		allLines = configFile.readlines()
		for aLine in allLines:
			if aLine.startswith('PROJECT_NAME'):
				nameItem = aLine.strip().split('=')[0]
				allLines.insert(allLines.index(aLine), nameItem + '= ' + projectName + '\n')
				allLines.remove(aLine)
			if aLine.startswith('PROJECT_NUMBER'):
				versionItem = aLine.strip().split('=')[0]
				allLines.insert(allLines.index(aLine), versionItem + '= ' + projectVersion + '\n')
				allLines.remove(aLine)
			# [seLain:] attention, the starts with must be compared with 'INPUT  ', ot the 'INPUT_FILTER' will be also replaces,
			# which will cause preprocessing error and parsing error
			if aLine.startswith('INPUT  '):
				inputItem = aLine.strip().split('=')[0]
				allLines.insert(allLines.index(aLine), inputItem + '= ' + PROJECT_SRC_PATH + projectDirName + '\n')
				print '[1] ', aLine, 'end'
				print '[2] ', inputItem + '= ' + PROJECT_SRC_PATH + projectDirName + '\n', 'end'
				allLines.remove(aLine)
			if aLine.startswith('OUTPUT_DIRECTORY'):
				inputItem = aLine.strip().split('=')[0]
				allLines.insert(allLines.index(aLine), inputItem + '= ' + OUTPUT_DIR_PATH + projectDirName + '-xml\n')
				allLines.remove(aLine)
		newConfigFile = file(PROJECT_SRC_PATH + projectDirName + '\\Doxyfile', 'w')
		newConfigFile.writelines(allLines)
		newConfigFile.close()
		
	## automatically doxygen execution
	for path in srcFullPaths:
		# [seLain:] since the doxygen configuration file already records the src and dist paths, the execution path should be able to be
		# in anywhere with configuration file, no 'cd' command needed ... check it out later
		command = 'cd ' + path + ' & ' + \
				'doxygen Doxyfile'
		print command
		os.system(command)


'''
configFile = file("project_srcs\spirit-1.6.3\Doxyfile")
allLines = configFile.readlines()
for aLine in allLines:
	if aLine.startswith('PROJECT_NAME'):
		nameItem = aLine.strip().split('=')[0]
		allLines.insert(allLines.index(aLine), nameItem + '= ' + 'spirit\n')
		allLines.remove(aLine)
	if aLine.startswith('PROJECT_NUMBER'):
		versionItem = aLine.strip().split('=')[0]
		allLines.insert(allLines.index(aLine), versionItem + '= ' + '2.5.1\n')
		allLines.remove(aLine)
	if aLine.startswith('INPUT'):
		inputItem = aLine.strip().split('=')[0]
		allLines.insert(allLines.index(aLine), inputItem + '= ' + 'E:\\FireFoxDW\\OSSA\\project_srcs\\' + 'spirit-2.5.1\n')
		allLines.remove(aLine)
newConfigFile = file("project_srcs/spirit-2.5.1/Doxyfile", 'w')
newConfigFile.writelines(allLines)
newConfigFile.close()
'''

